package sk.upjs.paz.heap;

import java.awt.Dimension;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.UIManager;

import sk.upjs.jpaz2.JPAZPanel;
import javax.swing.JSpinner;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JLabel;
import javax.swing.SpinnerNumberModel;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.util.Random;
import java.util.Scanner;

import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.swing.JCheckBox;

public class HeapsterFrame extends JFrame {

    private HeapPane heapPane;
    private JPanel contentPane;
    private JTextField valuesField;
    private JComboBox cmbGenerateTypes;

    /**
     * Launch the application.
     */
    public static void main(String[] args) {
	EventQueue.invokeLater(new Runnable() {
	    public void run() {
		try {
		    UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    HeapsterFrame frame = new HeapsterFrame();
		    frame.setVisible(true);
		} catch (Exception e) {
		    e.printStackTrace();
		}
	    }
	});
    }

    /**
     * Create the frame.
     */
    public HeapsterFrame() {
    	setTitle("Heapster (PAZ)");
	setResizable(false);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	setBounds(100, 100, 914, 605);
	contentPane = new JPanel();
	contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
	setContentPane(contentPane);

	JButton btnGenerate = new JButton("Generate numbers");
	btnGenerate.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		generateValues();
	    }
	});

	cmbGenerateTypes = new JComboBox();
	cmbGenerateTypes.addActionListener(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
		valuesField.setEnabled(cmbGenerateTypes.getSelectedIndex() == 3);
	    }
	});
	cmbGenerateTypes.setModel(new DefaultComboBoxModel(new String[] { "Arbitrary", "Heapified",
		"Heapified without root", "From the list" }));

	valuesField = new JTextField();
	valuesField.setEnabled(false);
	valuesField.setColumns(10);

	JPAZPanel heapPanel = new JPAZPanel();
	heapPanel.setPreferredSize(new Dimension(900, 520));
	heapPanel.setSize(new Dimension(900, 520));

	final JSpinner sizeSpinner = new JSpinner();
	sizeSpinner.addChangeListener(new ChangeListener() {
	    public void stateChanged(ChangeEvent evt) {
		heapPane.setSize((Integer) sizeSpinner.getValue());
	    }
	});
	sizeSpinner.setModel(new SpinnerNumberModel(15, 0, 15, 1));

	JLabel lblSize = new JLabel("Size:");

	JButton btnRootToEnd = new JButton("Swap first and last");
	btnRootToEnd.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    heapPane.swapFirstAndLast();
		}
	});
	
	JLabel lblToSwapValues = new JLabel("You can swap two values by clicking on the edge that connects these two values.");
	
	final JCheckBox chckbxShowIndices = new JCheckBox("Show indices");
	chckbxShowIndices.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    heapPane.setDisplayedIndices(chckbxShowIndices.isSelected());
		}
	});
	
	final JCheckBox chckbxShowComparators = new JCheckBox("Show comparators");
	chckbxShowComparators.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    heapPane.setDisplayComparators(chckbxShowComparators.isSelected());
		}
	});
	GroupLayout gl_contentPane = new GroupLayout(contentPane);
	gl_contentPane.setHorizontalGroup(
		gl_contentPane.createParallelGroup(Alignment.LEADING)
			.addGroup(gl_contentPane.createSequentialGroup()
				.addComponent(btnGenerate, GroupLayout.PREFERRED_SIZE, 160, GroupLayout.PREFERRED_SIZE)
				.addGap(6)
				.addComponent(cmbGenerateTypes, GroupLayout.PREFERRED_SIZE, 127, GroupLayout.PREFERRED_SIZE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(valuesField, GroupLayout.PREFERRED_SIZE, 299, GroupLayout.PREFERRED_SIZE)
				.addGap(18)
				.addComponent(lblSize)
				.addPreferredGap(ComponentPlacement.UNRELATED)
				.addComponent(sizeSpinner, GroupLayout.PREFERRED_SIZE, 44, GroupLayout.PREFERRED_SIZE)
				.addPreferredGap(ComponentPlacement.RELATED, 62, Short.MAX_VALUE)
				.addComponent(btnRootToEnd, GroupLayout.PREFERRED_SIZE, 140, GroupLayout.PREFERRED_SIZE))
			.addComponent(heapPanel, GroupLayout.DEFAULT_SIZE, 898, Short.MAX_VALUE)
			.addGroup(gl_contentPane.createSequentialGroup()
				.addComponent(lblToSwapValues)
				.addPreferredGap(ComponentPlacement.RELATED, 268, Short.MAX_VALUE)
				.addComponent(chckbxShowComparators)
				.addPreferredGap(ComponentPlacement.UNRELATED)
				.addComponent(chckbxShowIndices))
	);
	gl_contentPane.setVerticalGroup(
		gl_contentPane.createParallelGroup(Alignment.LEADING)
			.addGroup(gl_contentPane.createSequentialGroup()
				.addGroup(gl_contentPane.createParallelGroup(Alignment.LEADING)
					.addComponent(btnGenerate)
					.addGroup(gl_contentPane.createSequentialGroup()
						.addGap(1)
						.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
							.addComponent(valuesField, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addComponent(lblSize)
							.addComponent(sizeSpinner, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)
							.addComponent(btnRootToEnd)))
					.addGroup(gl_contentPane.createSequentialGroup()
						.addGap(1)
						.addComponent(cmbGenerateTypes, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)))
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(heapPanel, GroupLayout.PREFERRED_SIZE, 511, GroupLayout.PREFERRED_SIZE)
				.addPreferredGap(ComponentPlacement.RELATED, 9, Short.MAX_VALUE)
				.addGroup(gl_contentPane.createParallelGroup(Alignment.BASELINE)
					.addComponent(lblToSwapValues)
					.addComponent(chckbxShowIndices)
					.addComponent(chckbxShowComparators)))
	);
	contentPane.setLayout(gl_contentPane);

	heapPane = new HeapPane();
	heapPane.setSize((Integer) sizeSpinner.getValue());
	heapPane.setDisplayedIndices(chckbxShowIndices.isSelected());
	heapPane.setDisplayComparators(chckbxShowComparators.isSelected());
	
	cmbGenerateTypes.setSelectedIndex(0);
	generateValues();
	heapPanel.bindTo(heapPane);
    }

    private void heapify(int[] values, int idx) {
	while (idx < values.length) {
	    int largestIdx = idx;
	    if ((2 * idx + 1 < values.length) && (values[2 * idx + 1] > values[largestIdx]))
		largestIdx = 2 * idx + 1;

	    if ((2 * idx + 2 < values.length) && (values[2 * idx + 2] > values[largestIdx]))
		largestIdx = 2 * idx + 2;

	    if (largestIdx != idx) {
		int tmp = values[idx];
		values[idx] = values[largestIdx];
		values[largestIdx] = tmp;
	    } else {
		break;
	    }

	    idx = largestIdx;
	}
    }

    /**
     * Generates the values
     */
    private void generateValues() {
	int[] numbers = new int[heapPane.getMaxSize()];
	int optionIndex = cmbGenerateTypes.getSelectedIndex();

	if (optionIndex < 3) {
	    Random generator = new Random();
	    for (int i = 0; i < numbers.length; i++)
		numbers[i] = 1 + generator.nextInt(99);

	    if (optionIndex == 1) {
		for (int i = numbers.length / 2; i >= 0; i--)
		    heapify(numbers, i);
	    }

	    if (optionIndex == 2) {
		for (int i = numbers.length / 2; i >= 1; i--)
		    heapify(numbers, i);
	    }
	} else {
	    // from the list
	    Scanner s = new Scanner(valuesField.getText().replace(',', ' '));
	    int idx = 0;
	    boolean wrongInput = false;
	    while (s.hasNextInt() && (idx < numbers.length)) {
		numbers[idx] = s.nextInt();
		if ((numbers[idx] < 1) || (numbers[idx] > 99)) {
		    wrongInput = true;
		    break;
		}

		idx++;
	    }

	    if ((wrongInput) || (s.hasNextInt())) {
		JOptionPane.showMessageDialog(this, "List must consist of at most " + numbers.length
			+ " comma separated integer values from range 1-99.", "Error", JOptionPane.ERROR_MESSAGE);
		return;
	    }
	}

	heapPane.setValues(numbers);
    }
}
