package sk.upjs.paz.heap;

import java.awt.Color;
import java.awt.Font;

import sk.upjs.jpaz2.*;

public class NumberValue extends Pane {

    /**
     * The value represented by this item
     */
    private int value;
    
    public NumberValue() {
	super(56, 56);
	setCenter(getWidth()/2, getHeight()/2);
	
	// set background transparency
	setTransparentBackground(true);
	setBorderWidth(0);

	repaintNumber();
    }

    private void repaintNumber() {
	clear();
	
	Turtle drawer = new Turtle();
	drawer.setVisible(false);
	add(drawer);
	
	// draw dot
	drawer.center();
	drawer.setFillColor(Color.orange);
	drawer.dot(getWidth()/2);
	
	// print number value
	drawer.setDirection(90);
	drawer.setFont(drawer.getFont().deriveFont(30f).deriveFont(Font.BOLD));
	drawer.printCenter(Integer.toString(value));
	
	remove(drawer);
    }

    
    public int getValue() {
        return value;
    }

    public void setValue(int value) {
        this.value = value;
        repaintNumber();
    }

    
}
